#include "Status.h"
#include "Conf.h"
#include "Common.h"

#define I_AM_ALIVE 	WAIT_AND_SIGNAL(statusObj->bEventsLock); \
					events = statusObj->GetEventsList(); \
					for(iter = events->begin(); iter != events->end(); iter++){ \
						if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId){ \
							(*iter)->uEventStatus = EVENT_RUNNING; \
							break; \
						} \
					} \
					UNLOCK(statusObj->bEventsLock);

#define STOP_ME 	WAIT_AND_SIGNAL(statusObj->bEventsLock); \
					events = statusObj->GetEventsList(); \
					for(iter = events->begin(); iter != events->end(); iter++){ \
						if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId){ \
							(*iter)->uEventStatus = EVENT_STOPPED; \
							(*iter)->uCommand = 0; \
							UNLOCK(statusObj->bEventsLock); \
							return TRUE; \
						} \
					} \
					UNLOCK(statusObj->bEventsLock);

#define WAIT_FOR_STOP 	BOOL bStop = FALSE; \
						while(bStop == FALSE){ \
							WAIT_AND_SIGNAL(statusObj->bEventsLock); \
							events = statusObj->GetEventsList(); \
							for(iter = events->begin(); iter != events->end(); iter++){ \
								if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId && \
									(*iter)->uCommand == EVENT_STOP){ \
									bStop = TRUE; \
									break; \
								} \
							} \
							UNLOCK(statusObj->bEventsLock); \
							MiniSleep(500); \
						}

#define CHECK_FOR_STOP	WAIT_AND_SIGNAL(statusObj->bEventsLock); \
						events = statusObj->GetEventsList(); \
						for(iter = events->begin(); iter != events->end(); iter++){ \
							if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId \
								&& (*iter)->uCommand == EVENT_STOP){ \
								(*iter)->uEventStatus = EVENT_STOPPED; \
								(*iter)->uCommand = 0; \
								UNLOCK(statusObj->bEventsLock); \
								return TRUE; \
							} \
						} \
						UNLOCK(statusObj->bEventsLock);

#define TRIGGER_ACTION(x)	WAIT_AND_SIGNAL(statusObj->bActionsLock); \
							actions = statusObj->GetActionsList(); \
							for(counter = 0, iterA = actions->begin(); iterA != actions->end(); iterA++, counter++){ \
								if(counter == x){ \
									(*iterA)->bTriggered = TRUE; \
									break; \
								} \
							} \
							UNLOCK(statusObj->bActionsLock);

#define COMMON_DATA(x) 	UINT MyID = x; \
	Status *statusObj = Status::self(); \
	list<EventStruct *>::iterator iter; \
	list<EventStruct *> *events; \
	pEventStruct myData = (pEventStruct)lpParam; \
	list<MacroActionStruct *>::iterator iterA; \
	list<MacroActionStruct *> *actions; \
	UINT counter;

DWORD WINAPI OnTimer(LPVOID lpParam) {
	COMMON_DATA(EVENT_TIMER);
	pTimerStruct myConf = (pTimerStruct)(myData->pParams);
	FILETIME ft, t_ft;
	SYSTEMTIME st;
	LARGE_INTEGER time, t_time;
	UINT wait;
	WCHAR pathName[MAX_PATH] = {0};

	// Queste due get servono solo per controllare che statusObj si trovi
	// in uno stato coerente
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL){
		STOP_ME;
	}

	I_AM_ALIVE;

	GetSystemTime(&st);
	SystemTimeToFileTime(&st, &ft);
	time.HighPart = ft.dwHighDateTime;
	time.LowPart = ft.dwLowDateTime;

	LOOP{
		switch(myConf->uType){
			case CONF_TIMER_SINGLE:
				wait = myConf->Lo_Delay;
				GetSystemTime(&st);
				SystemTimeToFileTime(&st, &t_ft);
				t_time.HighPart = t_ft.dwHighDateTime;
				t_time.LowPart = t_ft.dwLowDateTime;

				// Il tempo e' in 100-ns, 1ms sono 1000000ns e quindi
				// 1ms equivale a 10000 100-ns, percio' dividiamo per 10000
				// in modo da avere la differenza temporale in ms.
				if((t_time.QuadPart - time.QuadPart) / 10000 >= wait){
					TRIGGER_ACTION(myData->uActionId);
					STOP_ME;
				}

				break;
			case CONF_TIMER_REPEAT:
				wait = myConf->Lo_Delay;
				GetSystemTime(&st);
				SystemTimeToFileTime(&st, &t_ft);
				t_time.HighPart = t_ft.dwHighDateTime;
				t_time.LowPart = t_ft.dwLowDateTime;

				if((t_time.QuadPart - time.QuadPart) / 10000 >= wait){
					time.QuadPart = t_time.QuadPart;
					TRIGGER_ACTION(myData->uActionId);
				}

				break;
			case CONF_TIMER_DATE:
				time.HighPart = myConf->Hi_Delay;
				time.LowPart = myConf->Lo_Delay;

				GetSystemTime(&st);
				SystemTimeToFileTime(&st, &t_ft);
				t_time.HighPart = t_ft.dwHighDateTime;
				t_time.LowPart = t_ft.dwLowDateTime;

				if(t_time.QuadPart >= time.QuadPart){
					TRIGGER_ACTION(myData->uActionId);
					STOP_ME;
				}

				break;
			case CONF_TIMER_DELTA: break;
				// XXX - Da implementare (Lo e Hi sono in FILETIME)
				/*FILETIME cft;
				HANDLE hMod = INVALID_HANDLE_VALUE;
				LARGE_INTEGER c_time;
				GetModuleFileName(NULL, pathName, MAX_PATH);
				hMod = CreateFile(pathName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
				GetFileTime(hMod, &cft, NULL, NULL);
				c_time.HighPart = cft.dwHighDateTime;
				c_time.LowPart = cft.dwLowDateTime;
				GetSystemTimeAsFileTime(&t_ft);
				t_time.HighPart = t_ft.dwHighDateTime;
				t_time.LowPart = t_ft.dwLowDateTime;*/

				//if(c_time.QuadPart >= myConf->Hi_Delay)
			default: 
				STOP_ME;
				break;
		}

		Sleep(450);
		CHECK_FOR_STOP;
	}

	STOP_ME;
}

DWORD WINAPI OnSms(LPVOID lpParam) {
	COMMON_DATA(EVENT_SMS);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL){
		STOP_ME;
	}

	I_AM_ALIVE;


	STOP_ME;
	return 0;
}

DWORD WINAPI OnCall(LPVOID lpParam) {
	COMMON_DATA(EVENT_CALL);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL){
		STOP_ME;
	}

	I_AM_ALIVE;


	STOP_ME;
	return 0;
}

DWORD WINAPI OnConnection(LPVOID lpParam) {
	COMMON_DATA(EVENT_CONNECTION);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL){
		STOP_ME;
	}

	I_AM_ALIVE;


	STOP_ME;
	return 0;
}

DWORD WINAPI OnProcess(LPVOID lpParam) {
	COMMON_DATA(EVENT_PROCESS);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL){
		STOP_ME;
	}

	I_AM_ALIVE;


	STOP_ME;
	return 0;
}